'From Squeak 1.2 of June 29, 1997 on 19 October 1998 at 9:07:57 am'!

!Parser methodsFor: 'language C scanning' stamp: 'The Ghost 10/8/98 09:36'!
bump
	source next. ^source peek! !

!Parser methodsFor: 'language C scanning'!
expressionForLanguageC
	"Pick up C code between { ... } inclusive as aString and build a #languageC node with it."
	| start end text |
"self halt: 'Start of expressionForLanguageC'."
	self skipToLeftOfBrace.
	start := source position.
	self scanCBlock ifFalse: [^false].
	end := source position.
	text := source copyFrom: start + 1 to: end.
	LanguageCNode debugging ifTrue: [Transcript cr; show: 'Picked up "',text, '"'].
	((parseNode _ LanguageCNode new) parser: self text: text) ifFalse: [
		self expected: 'illegal c syntax'. ^false].
	source position: end. 
	self resumeAfterRightBrace. 
"self halt: 'End of expressionForLanguageC'."
	^true! !

!Parser methodsFor: 'language C scanning' stamp: 'The Ghost 10/8/98 12:38'!
repositionScanner
	self advance; advance; advance; advance. ! !

!Parser methodsFor: 'language C scanning' stamp: 'The Ghost 10/8/98 13:39'!
resumeAfterRightBrace
	hereChar := $ .
	self advance; advance; advance! !

!Parser methodsFor: 'language C scanning' stamp: 'The Ghost 10/8/98 11:29'!
scanCBlock
	"Move past { to terminating }."
	| next |
	next := self bump.
	[next == $}] whileFalse: [
		next isNil ifTrue: [self expected: '}'. ^false].
		next == $" ifTrue: ["c string: e.g., ""....\n...\t....\""...."" (quotes had to be doubled)"
			self scanCString ifFalse: [^false].
			next := source peek] ifFalse: [
		next == ${ ifTrue: ["c block: e.g., {...}"
			self scanCBlock ifFalse: [^false].
			next := source peek] ifFalse: [
		next == $' ifTrue: ["c character: e.g., {...}"
			self scanCCharacter ifFalse: [^false].
			next := source peek] ifFalse: [
		next := self bump]]]].
	next := self bump.
	^true! !

!Parser methodsFor: 'language C scanning' stamp: 'The Ghost 10/8/98 09:52'!
scanCCharacter
	"Move past single quote to terminating single quote."
	| next |
	next := self bump.
	[next == $'] whileFalse: [
		next isNil ifTrue: [self expected: 'terminating C character quote'. ^false] ifFalse: [
		next == $\ ifTrue: [next := self bump] ifFalse: [
		next := self bump]]].
	next := self bump.
	^true! !

!Parser methodsFor: 'language C scanning' stamp: 'The Ghost 10/8/98 09:50'!
scanCString
	"Move past double quote to terminating double quote."
	| next |
	next := self bump.
	[next == $"] whileFalse: [
		next isNil ifTrue: [self expected: 'terminating C string quote'. ^false] ifFalse: [
		next == $\ ifTrue: [next := self bump] ifFalse: [
		next := self bump]]].
	next := self bump.
	^true! !

!Parser methodsFor: 'language C scanning' stamp: 'The Ghost 10/8/98 12:33'!
skipToLeftOfBrace
	[source skip: -1. source peek == ${] whileFalse: [].! !
